/*
Navicat MySQL Data Transfer

Source Server         : argo1
Source Server Version : 50528
Source Host           : argo1.cityhall.yar.ru:3306
Source Database       : invent2015free

Target Server Type    : MYSQL
Target Server Version : 50528
File Encoding         : 65001

Date: 2015-02-23 23:36:15
*/

SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for `cdrom`
-- ----------------------------
DROP TABLE IF EXISTS `cdrom`;
CREATE TABLE `cdrom` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of cdrom
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `codeoperation`
-- ----------------------------
DROP TABLE IF EXISTS `codeoperation`;
CREATE TABLE `codeoperation` (
`Code`  int(11) NOT NULL ,
`Name`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
PRIMARY KEY (`Code`, `Name`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of codeoperation
-- ----------------------------
BEGIN;
INSERT INTO `codeoperation` VALUES ('1', 'Поиск пользователя'), ('2', 'Поиск компьютера по имени  (IP-адресу)'), ('3', 'Поиск по номеру телефона'), ('4', 'Поиск по номеру кабинета'), ('5', 'Поиск компьютеров пользователя'), ('6', 'Получение сведений о компьютере'), ('7', 'Поиск компьютера по инвентарному номеру'), ('8', 'Поиск компьютера по серийному номеру');
COMMIT;

-- ----------------------------
-- Table structure for `comp`
-- ----------------------------
DROP TABLE IF EXISTS `comp`;
CREATE TABLE `comp` (
`ID`  int(11) NOT NULL ,
`OS`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`OSVersion`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`OSUpdateVer`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`OSSerialNumber`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`MBManufacturer`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`MB`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`TotalMemory`  int(11) NULL DEFAULT NULL ,
`OSArchitecture`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`NAME`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`DOMAIN`  varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`USERID`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Description`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Organization`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`SystemType`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`NumberOfProcessors`  int(11) NULL DEFAULT NULL ,
`NumberOfLogicalProcessors`  int(11) NULL DEFAULT NULL ,
`FreePhysicalMemory`  int(11) NULL DEFAULT NULL ,
`InstallDate`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`WindowsDirectory`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`SystemDirectory`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`BIOSManufacturer`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`BIOSName`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`BIOSVersion`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`ReleaseDate`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
PRIMARY KEY (`ID`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of comp
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `compmonitor`
-- ----------------------------
DROP TABLE IF EXISTS `compmonitor`;
CREATE TABLE `compmonitor` (
`id`  int(11) NOT NULL ,
`Model`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`SerialNumber`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`ManufacturerID`  varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`Date`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`DeviceID`  varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`Version`  varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`uid`  int(11) NULL DEFAULT NULL ,
`InvNumber`  varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
PRIMARY KEY (`id`, `Model`, `SerialNumber`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of compmonitor
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `compprinter`
-- ----------------------------
DROP TABLE IF EXISTS `compprinter`;
CREATE TABLE `compprinter` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`ShareName`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`Port`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`DefP`  int(11) NOT NULL DEFAULT 0 ,
`PrinterStatus`  int(11) NULL DEFAULT NULL ,
`PrinterState`  int(11) NULL DEFAULT NULL ,
`InvNumber`  varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`SerialNumber`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`uid`  int(11) NULL DEFAULT NULL ,
PRIMARY KEY (`ID`, `Name`, `ShareName`, `Port`, `DefP`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of compprinter
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `cpu`
-- ----------------------------
DROP TABLE IF EXISTS `cpu`;
CREATE TABLE `cpu` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Caption`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`NumberOfCores`  int(11) NULL DEFAULT NULL ,
`NumberOfLogicalProc`  int(11) NULL DEFAULT NULL ,
`CurrentClockSpeed`  int(11) NULL DEFAULT NULL ,
`ExtClock`  int(11) NULL DEFAULT NULL ,
`Socket`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`L2CacheSize`  int(11) NULL DEFAULT NULL ,
`L2CacheSpeed`  int(11) NULL DEFAULT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of cpu
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `device`
-- ----------------------------
DROP TABLE IF EXISTS `device`;
CREATE TABLE `device` (
`ID`  int(11) NOT NULL ,
`NAME`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
PRIMARY KEY (`ID`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of device
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `disk`
-- ----------------------------
DROP TABLE IF EXISTS `disk`;
CREATE TABLE `disk` (
`ID`  int(11) NOT NULL ,
`Model`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Size`  int(11) NULL DEFAULT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of disk
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `ethernet`
-- ----------------------------
DROP TABLE IF EXISTS `ethernet`;
CREATE TABLE `ethernet` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`IPAdress`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`MACAdress`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
PRIMARY KEY (`ID`, `Name`, `MACAdress`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of ethernet
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `fsize`
-- ----------------------------
DROP TABLE IF EXISTS `fsize`;
CREATE TABLE `fsize` (
`id`  int(11) NOT NULL AUTO_INCREMENT ,
`FileName`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`FileSize`  int(11) NOT NULL DEFAULT 0 ,
`RecCount`  int(11) NULL DEFAULT 0 ,
PRIMARY KEY (`id`, `FileName`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
AUTO_INCREMENT=3

;

-- ----------------------------
-- Records of fsize
-- ----------------------------
BEGIN;
INSERT INTO `fsize` VALUES ('1', 'log_running', '0', '0'), ('2', 'netscan', '0', '0');
COMMIT;

-- ----------------------------
-- Table structure for `history`
-- ----------------------------
DROP TABLE IF EXISTS `history`;
CREATE TABLE `history` (
`id`  int(11) NOT NULL AUTO_INCREMENT ,
`Code`  int(11) NOT NULL ,
`Data`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`User`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
PRIMARY KEY (`id`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
AUTO_INCREMENT=1

;

-- ----------------------------
-- Records of history
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `holder`
-- ----------------------------
DROP TABLE IF EXISTS `holder`;
CREATE TABLE `holder` (
`ID`  int(11) NOT NULL ,
`NAME`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
PRIMARY KEY (`ID`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of holder
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `installsoft`
-- ----------------------------
DROP TABLE IF EXISTS `installsoft`;
CREATE TABLE `installsoft` (
`id`  int(11) NOT NULL ,
`name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`version`  varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`date`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`manufacturer`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of installsoft
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `log`
-- ----------------------------
DROP TABLE IF EXISTS `log`;
CREATE TABLE `log` (
`ID`  int(11) NOT NULL AUTO_INCREMENT ,
`DIRECT`  varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`DATE`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`TIME`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`COMPUTER`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`ACCOUNT`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
PRIMARY KEY (`ID`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
AUTO_INCREMENT=1

;

-- ----------------------------
-- Records of log
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `logicaldisk`
-- ----------------------------
DROP TABLE IF EXISTS `logicaldisk`;
CREATE TABLE `logicaldisk` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`Size`  int(11) NULL DEFAULT NULL ,
`FileSystem`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`FreeSpace`  int(11) NULL DEFAULT NULL ,
PRIMARY KEY (`ID`, `Name`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of logicaldisk
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `main`
-- ----------------------------
DROP TABLE IF EXISTS `main`;
CREATE TABLE `main` (
`id`  int(11) NOT NULL AUTO_INCREMENT ,
`SnN`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`InN`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`NAME`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '1' ,
`HOLDER`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '1' ,
`PLACE`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`TYPE`  int(4) NOT NULL ,
`DATE`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`INFO`  text CHARACTER SET utf8 COLLATE utf8_general_ci NULL ,
`QUANT`  int(11) NOT NULL DEFAULT 1 ,
`REPARE`  tinyint(4) NOT NULL DEFAULT 0 ,
`EXCLUDE`  tinyint(4) NOT NULL DEFAULT 0 ,
`PREEXCLUDE`  tinyint(4) NOT NULL DEFAULT 0 ,
`INVENT`  tinyint(4) NOT NULL DEFAULT 1 ,
`NUM`  int(11) NOT NULL DEFAULT 1 ,
`Department`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Organization`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`RecDate`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '01.01.1900' ,
`InventDate`  varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
PRIMARY KEY (`id`, `SnN`, `InN`, `NAME`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
AUTO_INCREMENT=1

;

-- ----------------------------
-- Records of main
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `memory`
-- ----------------------------
DROP TABLE IF EXISTS `memory`;
CREATE TABLE `memory` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Slot`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`Capacity`  int(11) NULL DEFAULT NULL ,
`Speed`  int(11) NULL DEFAULT NULL ,
PRIMARY KEY (`ID`, `Slot`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of memory
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `phonebook`
-- ----------------------------
DROP TABLE IF EXISTS `phonebook`;
CREATE TABLE `phonebook` (
`ID`  int(11) NOT NULL AUTO_INCREMENT ,
`FIO`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' ,
`Organization`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Department`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Post`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`tel1`  varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`tel2`  varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`tel3`  varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Address`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Office`  varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`OwnerID`  varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
PRIMARY KEY (`ID`, `FIO`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
AUTO_INCREMENT=1

;

-- ----------------------------
-- Records of phonebook
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `port`
-- ----------------------------
DROP TABLE IF EXISTS `port`;
CREATE TABLE `port` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Type`  tinyint(4) NULL DEFAULT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of port
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `scsi`
-- ----------------------------
DROP TABLE IF EXISTS `scsi`;
CREATE TABLE `scsi` (
`id`  int(11) NOT NULL ,
`NAME`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of scsi
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `sound`
-- ----------------------------
DROP TABLE IF EXISTS `sound`;
CREATE TABLE `sound` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of sound
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `tellog`
-- ----------------------------
DROP TABLE IF EXISTS `tellog`;
CREATE TABLE `tellog` (
`id`  int(11) NOT NULL AUTO_INCREMENT ,
`FIO`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Organization`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`Telephone`  varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`Date`  varchar(15) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`Time`  varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`Department`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`OwnerID`  varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`TelephoneON`  varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
PRIMARY KEY (`id`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci
AUTO_INCREMENT=1

;

-- ----------------------------
-- Records of tellog
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for `type`
-- ----------------------------
DROP TABLE IF EXISTS `type`;
CREATE TABLE `type` (
`id`  int(4) NOT NULL ,
`NAME`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
`PIC`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
PRIMARY KEY (`id`, `NAME`)
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of type
-- ----------------------------
BEGIN;
INSERT INTO `type` VALUES ('1', 'системный блок', 'img\\comp.png'), ('2', 'монитор', 'img\\monitor.png'), ('3', 'принтер', 'img\\print.png'), ('4', 'сканер', 'img\\scaner.png'), ('5', 'сервер', null), ('6', 'ИБП', null), ('7', 'плазменая панель, телевизор', 'img\\tv.png'), ('8', 'телефон', null), ('9', 'динамики', 'img\\sound.png'), ('10', 'звуковое оборудование', 'img\\sound2.png'), ('11', 'точка доступа', null), ('12', 'роутер', null), ('13', 'ноутбук', 'img\\notebook.png'), ('14', 'микрофон', 'img\\microphone.png'), ('15', 'Микшерный пульт', 'img\\mix.png'), ('16', 'МФУ', 'img\\mfu.png'), ('17', 'ламповый проектор', 'img\\projector.png'), ('18', 'сетевое оборудование', 'img\\net.png'), ('19', 'факсимильный аппарат', 'img\\fax.png'), ('20', 'комутатор', null), ('21', 'камера', 'img\\video.png'), ('999', 'тип не определен', 'img\\unknown.png');
COMMIT;

-- ----------------------------
-- Table structure for `video`
-- ----------------------------
DROP TABLE IF EXISTS `video`;
CREATE TABLE `video` (
`ID`  int(11) NOT NULL ,
`Name`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`RAM`  int(4) NULL DEFAULT NULL ,
`Processor`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL ,
`VideoModeDescription`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL 
)
ENGINE=InnoDB
DEFAULT CHARACTER SET=utf8 COLLATE=utf8_general_ci

;

-- ----------------------------
-- Records of video
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Procedure structure for `clear_db`
-- ----------------------------
DROP PROCEDURE IF EXISTS `clear_db`;
DELIMITER ;;
CREATE DEFINER=`adm`@`%` PROCEDURE `clear_db`()
BEGIN

DELETE FROM `cdrom`;
DELETE FROM `comp`;
DELETE FROM `compprinter`;
DELETE FROM `cpu`;
DELETE FROM `disk`;
DELETE FROM `ethernet`;
DELETE FROM `history`;
DELETE FROM `logicaldisk`;
DELETE FROM `main`;
DELETE FROM `memory`;
DELETE FROM `port`;
DELETE FROM `scsi`;
DELETE FROM `sound`;
DELETE FROM `tellog`;
DELETE FROM `video`;
DELETE FROM `compmonitor`;
DELETE FROM `installsoft`;


ALTER TABLE `main` AUTO_INCREMENT = 1;
ALTER TABLE `history` AUTO_INCREMENT = 1;
ALTER TABLE `tellog` AUTO_INCREMENT = 1;

END
;;
DELIMITER ;

-- ----------------------------
-- Procedure structure for `delete_all`
-- ----------------------------
DROP PROCEDURE IF EXISTS `delete_all`;
DELIMITER ;;
CREATE DEFINER=`adm`@`%` PROCEDURE `delete_all`()
BEGIN

DELETE FROM `cdrom`;
DELETE FROM `comp`;
DELETE FROM `compprinter`;
DELETE FROM `cpu`;
DELETE FROM `disk`;
DELETE FROM `ethernet`;
DELETE FROM `history`;
DELETE FROM `log`;
DELETE FROM `logicaldisk`;
DELETE FROM `main`;
DELETE FROM `memory`;
DELETE FROM `phonebook`;
DELETE FROM `port`;
DELETE FROM `scsi`;
DELETE FROM `sound`;
DELETE FROM `tellog`;
DELETE FROM `video`;
DELETE FROM `fsize`;
DELETE FROM `compmonitor`;
DELETE FROM `installsoft`;


ALTER TABLE `main` AUTO_INCREMENT = 1;
ALTER TABLE `history` AUTO_INCREMENT = 1;
ALTER TABLE `log` AUTO_INCREMENT = 1;
ALTER TABLE `phonebook` AUTO_INCREMENT = 1;
ALTER TABLE `tellog` AUTO_INCREMENT = 1;
ALTER TABLE `fsize` AUTO_INCREMENT = 1;

INSERT INTO fsize (filename,filesize,reccount) VALUES("log_running",0,0);
INSERT INTO fsize (filename,filesize,reccount) VALUES("netscan",0,0);

END
;;
DELIMITER ;

-- ----------------------------
-- Auto increment value for `fsize`
-- ----------------------------
ALTER TABLE `fsize` AUTO_INCREMENT=3;

-- ----------------------------
-- Auto increment value for `history`
-- ----------------------------
ALTER TABLE `history` AUTO_INCREMENT=1;

-- ----------------------------
-- Auto increment value for `log`
-- ----------------------------
ALTER TABLE `log` AUTO_INCREMENT=1;

-- ----------------------------
-- Auto increment value for `main`
-- ----------------------------
ALTER TABLE `main` AUTO_INCREMENT=1;

-- ----------------------------
-- Auto increment value for `phonebook`
-- ----------------------------
ALTER TABLE `phonebook` AUTO_INCREMENT=1;

-- ----------------------------
-- Auto increment value for `tellog`
-- ----------------------------
ALTER TABLE `tellog` AUTO_INCREMENT=1;
