Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objOutFile = objFSO.CreateTextFile("subnets.csv", True) 
Err.Clear     

    Set objRootDSE = GetObject("LDAP://RootDSE") 
    strConfigurationNC = objRootDSE.Get("configurationNamingContext") 
    strSubnetsContainer = "LDAP://cn=Subnets,cn=Sites," & strConfigurationNC 
    Set objSubnetsContainer = GetObject(strSubnetsContainer) 
    objSubnetsContainer.Filter = Array("subnet") 
    Set objHash = CreateObject("Scripting.Dictionary") 
    For Each objSubnet In objSubnetsContainer 
        strSubnetRDN = objSubnet.cn 
        strDescription = objSubnet.Description 
        strLocation = objSubnet.Location
        'if strSubnetRDN="10.20.1.0/24" then  
        objOutFile.WriteLine  strSubnetRDN  & " * " & _ 
                      strDescription & " * " & strLocation 
    Next
  
 objOutFile.Close